Option Explicit
Option Base 0

Const MaxCampos = 44

Sub BorrarTabla ()
    Dim MyDb As Database
    Dim MyTabla As Table
 
    Set MyDb = OpenDatabase(pathDB)
    MyDb.TableDefs.Delete ("Resultados")
End Sub

Sub CargarDatos ()
    ReDim dato(MaxCampos) As Variant  '*&%$#! VB #$$#@?/^*
    Dim archivoresult As String
    Dim MyDb As Database
    Dim MyTabla As Table
    Dim i As Integer
    Dim frmStat As formImpStat
    Dim iLinea As Integer
    Dim iStatus As Integer

    archivoresult = ImportarDesde()
    If archivoresult = "" Then
        Exit Sub
    End If


    pathDB = ImportarHacia()
    If pathDB = "" Then
        Exit Sub
    End If

    ' Trato de abrir la base
    On Error GoTo ErrorHandler
    Set MyDb = OpenDatabase(pathDB)
    On Error GoTo 0

    If iStatus = 0 Then
        i = MsgBox("La base de datos existe. Desea conservar los datos existentes?", MB_YESNOCANCEL + MB_ICONQUESTION)
        Select Case i
            Case IDNO
                Call BorrarTabla
                Call CrearTabla
            Case IDCANCEL
                Exit Sub
        End Select
    Else
        Call crearBase
        Call CrearTabla
        Set MyDb = OpenDatabase(pathDB)
    End If

    'Abro la tabla
    Set MyTabla = MyDb.OpenTable("Resultados")

    Set frmStat = New formImpStat
    iLinea = 0
    frmStat.Show
    frmStat.Label2.Caption = Str$(iLinea)
    frmStat.Refresh
    
    'Copio cada linea del archivo a la tabla
    Open archivoresult For Input Access Read As 1 Len = 500
    BeginTrans 'las transacciones estn para que grabe a disco
    While Not EOF(1) 'cada 50 registros y no todo el tiempo
        MyTabla.AddNew
        For i = 0 To MaxCampos - 1
            Input #1, dato(i)
            MyTabla.Fields(i).Value = dato(i)
        Next
        MyTabla.Update
        iLinea = iLinea + 1
        If iLinea Mod 50 = 0 Then
            frmStat.Label2.Caption = Str$(iLinea)
            frmStat.Refresh
            CommitTrans 'cada 20 registros termino una transaccion
            BeginTrans  ' y empiezo otra
        End If
    Wend
    CommitTrans
    Close #1
    Unload frmStat
    Exit Sub
ErrorHandler:
    iStatus = 0
    If Err = 3024 Then
        iStatus = 1
    End If
    Resume Next
End Sub

Sub crearBase ()
    Dim MyDb As Database
    Set MyDb = CreateDatabase(pathDB, DB_LANG_GENERAL)
End Sub

Sub CrearTabla ()
    Dim MyDb As Database
    Dim myTableDef As New tabledef
 
    Dim MyIndex1 As New Index
    Dim MyIndex2 As New Index
 
    Dim myfield1 As New field
    Dim myfield2 As New field
    Dim myfield3 As New field
    Dim myfield4 As New field
    Dim myfield5 As New field
    Dim myfield6 As New field
    Dim myfield7 As New field
    Dim myfield8 As New field
    Dim myfield9 As New field
    Dim myfield10 As New field
    Dim myfield11 As New field
    Dim myfield12 As New field
    Dim myfield13 As New field
    Dim myfield14 As New field
    Dim myfield15 As New field
    Dim myfield16 As New field
    Dim myfield17 As New field
    Dim myfield18 As New field
    Dim myfield19 As New field
    Dim myfield20 As New field
    Dim myfield21 As New field
    Dim myfield22 As New field
    Dim myfield23 As New field
    Dim myfield24 As New field
    Dim myfield25 As New field
    Dim myfield26 As New field
    Dim myfield27 As New field
    Dim myfield28 As New field
    Dim myfield29 As New field
    Dim myfield30 As New field
    Dim myfield31 As New field
    Dim myfield32 As New field
    Dim myfield33 As New field
    Dim myfield34 As New field
    Dim myfield35 As New field
    Dim myfield36 As New field
    Dim myfield37 As New field
    Dim myfield38 As New field
    Dim myfield39 As New field
    Dim myfield40 As New field
    Dim myfield41 As New field
    Dim myfield42 As New field
    Dim myfield43 As New field
    Dim myfield44 As New field


    '  esta linea es para crear la BD si es que desaparecio
    '    Set MyDB = CreateDatabase("C:\uba\str\trabajo\vb\str.MDB", DB_LANG_GENERAL)
     Set MyDb = OpenDatabase(pathDB)
    '   mydb.TableDefs.Delete "Resultados"

    myTableDef.Name = "Resultados"
    
    myfield1.Name = "Algoritmo"
    myfield1.Type = DB_TEXT
    myfield1.Size = 11
    myTableDef.Fields.Append myfield1

    myfield2.Name = "Clase"
    myfield2.Type = DB_INTEGER
    myTableDef.Fields.Append myfield2

    myfield3.Name = "benchmark"
    myfield3.Type = DB_TEXT
    myfield3.Size = 5
    myTableDef.Fields.Append myfield3

    myfield4.Name = "remMin"
    myfield4.Type = DB_SINGLE
    myTableDef.Fields.Append myfield4

    myfield5.Name = "remMax"
    myfield5.Type = DB_SINGLE
    myTableDef.Fields.Append myfield5

    myfield6.Name = "remAvg"
    myfield6.Type = DB_SINGLE
    myTableDef.Fields.Append myfield6

    myfield7.Name = "remStd"
    myfield7.Type = DB_SINGLE
    myTableDef.Fields.Append myfield7

    myfield8.Name = "usoMin"
    myfield8.Type = DB_SINGLE
    myTableDef.Fields.Append myfield8

    myfield9.Name = "usoMax"
    myfield9.Type = DB_SINGLE
    myTableDef.Fields.Append myfield9

    myfield10.Name = "usoAvg"
    myfield10.Type = DB_SINGLE
    myTableDef.Fields.Append myfield10

    myfield11.Name = "usoStd"
    myfield11.Type = DB_SINGLE
    myTableDef.Fields.Append myfield11

    myfield12.Name = "ccMin"
    myfield12.Type = DB_SINGLE
    myTableDef.Fields.Append myfield12

    myfield13.Name = "ccMax"
    myfield13.Type = DB_SINGLE
    myTableDef.Fields.Append myfield13

    myfield14.Name = "ccAvg"
    myfield14.Type = DB_SINGLE
    myTableDef.Fields.Append myfield14

    myfield15.Name = "ccStd"
    myfield15.Type = DB_SINGLE
    myTableDef.Fields.Append myfield15

    myfield16.Name = "idleMin"
    myfield16.Type = DB_SINGLE
    myTableDef.Fields.Append myfield16

    myfield17.Name = "idleMax"
    myfield17.Type = DB_SINGLE
    myTableDef.Fields.Append myfield17

    myfield18.Name = "idleAvg"
    myfield18.Type = DB_SINGLE
    myTableDef.Fields.Append myfield18

    myfield19.Name = "idleStd"
    myfield19.Type = DB_SINGLE
    myTableDef.Fields.Append myfield19

    myfield20.Name = "grMin"
    myfield20.Type = DB_SINGLE
    myTableDef.Fields.Append myfield20

    myfield21.Name = "grMax"
    myfield21.Type = DB_SINGLE
    myTableDef.Fields.Append myfield21

    myfield22.Name = "grAvg"
    myfield22.Type = DB_SINGLE
    myTableDef.Fields.Append myfield22

    myfield23.Name = "grStd"
    myfield23.Type = DB_SINGLE
    myTableDef.Fields.Append myfield23

    myfield24.Name = "grPerMin"
    myfield24.Type = DB_SINGLE
    myTableDef.Fields.Append myfield24

    myfield25.Name = "grPerMax"
    myfield25.Type = DB_SINGLE
    myTableDef.Fields.Append myfield25

    myfield26.Name = "grPerAvg"
    myfield26.Type = DB_SINGLE
    myTableDef.Fields.Append myfield26

    myfield27.Name = "grPerStd"
    myfield27.Type = DB_SINGLE
    myTableDef.Fields.Append myfield27

    myfield28.Name = "grAperMin"
    myfield28.Type = DB_SINGLE
    myTableDef.Fields.Append myfield28

    myfield29.Name = "grAperMax"
    myfield29.Type = DB_SINGLE
    myTableDef.Fields.Append myfield29

    myfield30.Name = "grAperAvg"
    myfield30.Type = DB_SINGLE
    myTableDef.Fields.Append myfield30

    myfield31.Name = "grAperStd"
    myfield31.Type = DB_SINGLE
    myTableDef.Fields.Append myfield31

    myfield32.Name = "grPondMin"
    myfield32.Type = DB_SINGLE
    myTableDef.Fields.Append myfield32

    myfield33.Name = "grPondMax"
    myfield33.Type = DB_SINGLE
    myTableDef.Fields.Append myfield33

    myfield34.Name = "grPondAvg"
    myfield34.Type = DB_SINGLE
    myTableDef.Fields.Append myfield34

    myfield35.Name = "grPondStd"
    myfield35.Type = DB_SINGLE
    myTableDef.Fields.Append myfield35

    myfield36.Name = "grPerPondMin"
    myfield36.Type = DB_SINGLE
    myTableDef.Fields.Append myfield36

    myfield37.Name = "grPerPondMax"
    myfield37.Type = DB_SINGLE
    myTableDef.Fields.Append myfield37

    myfield38.Name = "grPerPondAvg"
    myfield38.Type = DB_SINGLE
    myTableDef.Fields.Append myfield38

    myfield39.Name = "grPerPondStd"
    myfield39.Type = DB_SINGLE
    myTableDef.Fields.Append myfield39

    myfield40.Name = "grAperPondMin"
    myfield40.Type = DB_SINGLE
    myTableDef.Fields.Append myfield40

    myfield41.Name = "grAperPondMax"
    myfield41.Type = DB_SINGLE
    myTableDef.Fields.Append myfield41

    myfield42.Name = "grAperPondAvg"
    myfield42.Type = DB_SINGLE
    myTableDef.Fields.Append myfield42

    myfield43.Name = "grAperPondStd"
    myfield43.Type = DB_SINGLE
    myTableDef.Fields.Append myfield43

    myfield44.Name = "cant"
    myfield44.Type = DB_SINGLE
    myTableDef.Fields.Append myfield44

    MyIndex1.Name = "BenchAlg"
    MyIndex1.Fields = "benchmark;Algoritmo;Clase"
    myTableDef.Indexes.Append MyIndex1

    MyIndex2.Name = "Alg"
    MyIndex2.Fields = "Algoritmo;Clase"
    myTableDef.Indexes.Append MyIndex2
    
    MyDb.TableDefs.Append myTableDef

' actualizo el puntero del datacontrol a la tabla resultados
'    data1.RecordSource = "Resultados"
 '   data1.Refresh
 ' coment lo de arriba porque march el data control

End Sub

Function ImportarDesde () As String
    Dim i As Integer
    Dim j As Integer
    Dim extension As String

    On Error Resume Next
    Dim OpenFileName As String
    MDIform1.CMDialog1.Filename = ""
    MDIform1.CMDialog1.DialogTitle = "Importar desde"
    MDIform1.CMDialog1.Filter = "Archivos de texto (*.txt)|*.txt|Todos los archivos (*.*)|*.*"
    MDIform1.CMDialog1.DefaultExt = "TXT"
    MDIform1.CMDialog1.Action = 1
    If Err <> 32755 Then 'user pressed cancel
        OpenFileName = MDIform1.CMDialog1.Filename
        ImportarDesde = OpenFileName
    End If

End Function

Function ImportarHacia () As String
    Dim i As Integer
    Dim j As Integer
    Dim extension As String

    On Error Resume Next
    Dim OpenFileName As String
    MDIform1.CMDialog1.Filename = ""
    MDIform1.CMDialog1.DialogTitle = "Importar como"
    MDIform1.CMDialog1.Flags = OFN_HIDEREADONLY
    MDIform1.CMDialog1.Filter = "Base de datos (*.mdb)|*.mdb"
    MDIform1.CMDialog1.Action = 1
    MDIform1.CMDialog1.DefaultExt = "MDB"
    
    If Err <> 32755 Then 'user pressed cancel
        OpenFileName = MDIform1.CMDialog1.Filename
        ImportarHacia = OpenFileName
    End If

End Function

